//CharteDeCouleurs_201f.js
// 04.04.11 / Hans Haesler, Chtelard 52, CH-1018 Lausanne / <hsa@ringier.ch>
//DESCRIPTION:Crer une charte de couleurs

//// les rglages par dfaut /////////////////////////////////////////////////////////////////////
var yD = 10; // la distance (en mm) du bord suprieur da la page
var xD = 10; // la distance (en mm) du le bord gauche da la page
var nF = 21; // la valeur limite (le document est cach quand il y a davantage de blocs par range)
//// les rglages par dfaut /////////////////////////////////////////////////////////////////////

// activer l'affichage des dialogues
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// tester s'il y a un document ouvert
var noDoc = false;
if (app.documents.length == 0) {
	noDoc = true;
}
else {
	// mmoriser le chemin du document
	var curDoc = app.documents[0];
	try {
		var docFolder = curDoc.filePath;
		var docPath   = curDoc.fullName;
	}
	catch (e) {
		alert ("Enregistrer le document.", "Attention");
		exit();
	}
}

// appeler la fonction qui lit les rglages enregistrs
var allPrefs = getPrefs();
if (allPrefs != "") {
	var prefVal = allPrefs.split("\n");
	var cSt   = prefVal[0];
	if (cSt  == "true") { cSt = true; } else { cSt = false; }
	var mSt   = prefVal[1];
	if (mSt  == "true") { mSt = true; } else { mSt = false; }
	var ySt   = prefVal[2];
	if (ySt  == "true") { ySt = true; } else { ySt = false; }
	var kSt   = prefVal[3];
	if (kSt  == "true") { kSt = true; } else { kSt = false; }
	var cFix  = prefVal[4]*1;
	var mFix  = prefVal[5]*1;
	var yFix  = prefVal[6]*1;
	var kFix  = prefVal[7]*1;
	var xVal  = prefVal[8]*1;
	var stVal = prefVal[9]*1;
	var zVal  = prefVal[10]*1;
	var wdVal = prefVal[11]*1;
	var dVal  = prefVal[12]*1;
}
else {
	// lorsque le fichier des prfrences ne peut pas tre trouv, 
	// utiliser les valeurs par dfaut suivants
	var cFix  =   0;
	var cSt   =   0;
	var mFix  =   0;
	var mSt   =   1;
	var yFix  =   0;
	var ySt   =   0;
	var kFix  =   0;
	var kSt   =   1;
	var xVal  =   0;
	var stVal =   5;
	var zVal  = 100;
	var wdVal =   5;
	var dVal  =   1;
}

// dfinir "Jaune" et "Noir"
if ((app.locale)*1 == 1279477362) { // InDesign en franais
	var yChar = "J";
	var kChar = "N";
	var yelloCol = "Jaune";
	var blackCol = "Noir";
}
else if ((app.locale)*1 == 1279477613) { // InDesign en allemand
	var yChar = "Y";
	var kChar = "K";
	var yelloCol = "Gelb";
	var blackCol = "Schwarz";
}
else if ((app.locale)*1 == 1279477102 || (app.locale)*1 == 1279477097) { // InDesign en anglais
	var yChar = "Y";
	var kChar = "K";
	var yelloCol = "Yellow";
	var blackCol = "Black";
}
else {
	var yChar = "J";
	var kChar = "N";
	var yelloCol = "Jaune";
	var blackCol = "Noir";
}

// appeler la fonction qui affiche le dialogue et convertit les valeurs
var anArray = displayDialog();

// mettre le rsultat aux variables
var cDec = anArray[0];
var mDec = anArray[1];
var yDec = anArray[2];
var kDec = anArray[3];
var cPc  = anArray[4]*1;
var mPc  = anArray[5]*1;
var yPc  = anArray[6]*1;
var kPc  = anArray[7]*1;
var col1 = anArray[8];
var col2 = anArray[9];
var col3 = anArray[10];
var col4 = anArray[11];
var nFix = anArray[12]*1;
var xPc  = anArray[13]*1;
var sPc  = anArray[14]*1;
var zPc  = anArray[15]*1;
var fW   = anArray[16]*1;
var fH   = fW;
var dV   = anArray[17]*1;

// quand aucun composant de couleur fixe n'est slectionn, on doit dfinir
// lesquelles des paires de composants doivent tre superposes
if (nFix == 0) {
	var bDialog = app.dialogs.add({name:"Dfinir les paires de composants de couleur"});
	with (bDialog) {
		with (dialogColumns.add()) {
			with (dialogRows.add()) {
				with (dialogColumns.add()) {
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:"Slectionner parmi les quatre composants"});
						staticTexts.add({staticLabel:" "});
					}
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:"les deux paires  superposer"});
						staticTexts.add({staticLabel:" "});
					}
				}
			}
			with (dialogRows.add()) {
				with (borderPanels.add()) {
					staticTexts.add({staticLabel:" ", minWidth:70});
					with(decButtons = radiobuttonGroups.add()) {
						radiobuttonControls.add({staticLabel:col1 + " + " + col2 + "   |   " + col3 + " + " + col4, checkedState:1});
						radiobuttonControls.add({staticLabel:col1 + " + " + col3 + "   |   " + col2 + " + " + col4, checkedState:0});
						radiobuttonControls.add({staticLabel:col1 + " + " + col4 + "   |   " + col2 + " + " + col3, checkedState:0});
					}
					staticTexts.add({staticLabel:" ", minWidth:40});
				}
			}
		}
	}
	if(bDialog.show() == true) {
		var comDec = decButtons.selectedButton;
		// si le bouton 2 ou 3 est slectionn, croiser la dfinition
		if (comDec == 1) {
			var tmpCol = col3;
			col3 = col2;
			col2 = tmpCol;
		}
		else if (comDec == 2) {
			var tmpCol1 = col2;
			var tmpCol2 = col3;
			col2 = col4;
			col3 = tmpCol1;
			col4 = tmpCol2;
		}
		// supprimer le dialogue
		bDialog.destroy();
	}
	else {
		bDialog.destroy();
		exit();
	}
}
// quand un seul composant de couleur fixe est slectionn, on doit dfinir
// une paire de composants  superposer
else if (nFix == 1) {
	var cDialog = app.dialogs.add({name:"Dfinir la paire de composants"});
	with (cDialog) {
		with (dialogColumns.add()) {
			with (dialogRows.add()) {
				with (dialogColumns.add()) {
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:"Slectionner parmi les trois composants"});
						staticTexts.add({staticLabel:" "});
					}
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:"la paire  superposer"});
						staticTexts.add({staticLabel:" "});
					}
				}
			}
			with (dialogRows.add()) {
				with (borderPanels.add()) {
					staticTexts.add({staticLabel:" ", minWidth:70});
					with(decButtons = radiobuttonGroups.add()) {
						radiobuttonControls.add({staticLabel:col2 + " + " + col3, checkedState:1});
						radiobuttonControls.add({staticLabel:col2 + " + " + col4, checkedState:0});
						radiobuttonControls.add({staticLabel:col3 + " + " + col4, checkedState:0});
					}
					staticTexts.add({staticLabel:" ", minWidth:40});
				}
			}
		}
	}
	if(cDialog.show() == true) {
		var comDec = decButtons.selectedButton;
		// si le bouton 2 ou 3 est slectionn, croiser la dfinition
		if (comDec == 1) {
			var tmpCol = col3;
			col3 = col4;
			col4 = tmpCol;
		}
		else if (comDec == 2) {
			var tmpCol = col2;
			col2 = col3;
			col3 = col4;
			col4 = tmpCol;
		}
		// supprimer le dialogue
		cDialog.destroy();
	}
	else {
		cDialog.destroy();
		exit();
	}
}

if (noDoc == false) {
	// mmoriser les units de mesure
	// lorsque ce n'est pas 2053991795 (= millimtres), changer  millimtres
	hM = curDoc.viewPreferences.horizontalMeasurementUnits;
	vM = curDoc.viewPreferences.verticalMeasurementUnits;
	if (hM != 2053991795) {
		curDoc.viewPreferences.horizontalMeasurementUnits = MeasurementUnits.millimeters;
	}
	if (vM != 2053991795) {
		curDoc.viewPreferences.verticalMeasurementUnits = MeasurementUnits.millimeters;
	}
	// modifier le point zro  zro/zro
	var zP = curDoc.zeroPoint; 
	if (zP != [0,0]) { 
		curDoc.zeroPoint = [0,0]; 
	}
	// dverrouiller le calque actif (si ncessaire)
	var isLocked = false;
	var curLayer = app.activeWindow.activeLayer;
	if (curLayer.locked) {
		curLayer.locked = false;
		isLocked = true;
	}
}

// calculer le nombre de blocs d'une range
var mN = ((zPc - xPc) + sPc) / sPc;

// quand la distance entre rangs et colonne est zro, la modifier  -0.1 mm (= des raccords meilleurs  l'cran)
if (dV == 0) { dV = -0.1; }

// calculer la dimension minimale du document
var docW = Math.floor((mN * fW) + ((mN-1)*dV) + (xD*2));

if (noDoc) {
	if (docW > 5486.4) {
		var diffVal = docW-5486.4;
		alert ("La largeur du document ncessaire (= " + docW + " mm) \nest de " + diffVal + " mm au-del de la valeur maximale (= 5486.4 mm). \n\nO bien des blocs plus petits o bien un pas plus grand.", "Stop");
		exit();
	}
	// crer un document
	if (mN > nF) { // invisiblement (quand le nombre de blocs est au-dessus de la valeur dfinie)
		curDoc = app.documents.add(false, undefined);
	}
	else { // sinon l'afficher
		curDoc = app.documents.add();
	}
	curDoc.viewPreferences.horizontalMeasurementUnits = MeasurementUnits.millimeters;
	curDoc.viewPreferences.verticalMeasurementUnits = MeasurementUnits.millimeters;
	curDoc.documentPreferences.properties = {pageWidth:docW, pageHeight:docW, facingPages:false};
}
else {
	// vrifier si le document est assez grand
	var pWidth  = curDoc.documentPreferences.pageWidth;
	var pHeight = curDoc.documentPreferences.pageHeight;
	if (pWidth < (docW-xD) || pHeight < (docW-xD)) {
		alert ("Le document est trop petit.\n\nIl devrait mesurer " + docW + " mm x " + docW + " mm.", "Stop");
		resetAsBefore();
		exit();
	}
	if (mN > nF) { // quand le nombre de blocs est au-dessus de la valeur limite...
		// ... enregistrer le document, le fermer...
		curDoc.close(SaveOptions.yes);
		// ... et l'ouvrir invisiblement
		curDoc = app.open(File(docPath), false);
	}
}

// allouer les valeurs fixes dfinies aux variables c m y k
var c = m = y = k = 0;
if (cDec) { c = cPc; }
if (mDec) { m = mPc; }
if (yDec) { y = yPc; }
if (kDec) { k = kPc; }
// rduire les valeurs des composants variables par la valeur "pas"
if      (col1 == "Cyan")    { c = xPc-sPc; pt1 = 0; }
else if (col1 == "Magenta") { m = xPc-sPc; pt1 = 1; }
else if (col1 == yelloCol)  { y = xPc-sPc; pt1 = 2; }
else if (col1 == blackCol)  { k = xPc-sPc; pt1 = 3; }
if      (col2 == "Cyan")    { c = xPc-sPc; pt2 = 0; }
else if (col2 == "Magenta") { m = xPc-sPc; pt2 = 1; }
else if (col2 == yelloCol)  { y = xPc-sPc; pt2 = 2; }
else if (col2 == blackCol)  { k = xPc-sPc; pt2 = 3; }
if      (col3 == "Cyan")    { c = xPc-sPc; pt3 = 0; }
else if (col3 == "Magenta") { m = xPc-sPc; pt3 = 1; }
else if (col3 == yelloCol)  { y = xPc-sPc; pt3 = 2; }
else if (col3 == blackCol)  { k = xPc-sPc; pt3 = 3; }
if      (col4 == "Cyan")    { c = xPc-sPc; pt4 = 0; }
else if (col4 == "Magenta") { m = xPc-sPc; pt4 = 1; }
else if (col4 == yelloCol)  { y = xPc-sPc; pt4 = 2; }
else if (col4 == blackCol)  { k = xPc-sPc; pt4 = 3; }

// vrifier s'il y a d'autres couleurs ( part des quatre couleurs de base)
allSwatches = app.documents[0].swatches.everyItem().name;
if (allSwatches.length > 4) {
	// si c'est le cas, il va falloir vrifier si une nuance  crer n'existe pas dj
	makeSure = true;
}
else {
	var makeSure = false;
}

// prparer les valeurs de dcalage et de la position de dpart verticale
var yOff  = fH+dV;
var xOff  = fW+dV;
var y1    = yD-yOff;

// une boucle  travers les ranges
var ctr = 0;
for (var i=0; i<mN; i++) {
	y1 = y1+yOff; // la position verticale de la range actuelle
	x1 = xD;      // la valeur de dpart horizontal de la colonne
	if (nFix == 0) {
		// augmenter les valeurs variables par celle du pas
		if      (pt1 == 0) { c = c + sPc; }
		else if (pt1 == 1) { m = m + sPc; }
		else if (pt1 == 2) { y = y + sPc; }
		else if (pt1 == 3) { k = k + sPc; }
		if      (pt2 == 0) { c = c + sPc; }
		else if (pt2 == 1) { m = m + sPc; }
		else if (pt2 == 2) { y = y + sPc; }
		else if (pt2 == 3) { k = k + sPc; }
		// rtablir les valeurs variables  la valeur de dpart
		if      (pt3 == 0) { c = xPc; }
		else if (pt3 == 1) { m = xPc; }
		else if (pt3 == 2) { y = xPc; }
		else if (pt3 == 3) { k = xPc; }
		if      (pt4 == 0) { c = xPc; }
		else if (pt4 == 1) { m = xPc; }
		else if (pt4 == 2) { y = xPc; }
		else if (pt4 == 3) { k = xPc; }
	}
	if (nFix == 1) {
		// augmenter les valeurs variables par celle du pas
		if      (pt2 == 0) { c = c + sPc; }
		else if (pt2 == 1) { m = m + sPc; }
		else if (pt2 == 2) { y = y + sPc; }
		else if (pt2 == 3) { k = k + sPc; }
		if      (pt3 == 0) { c = c + sPc; }
		else if (pt3 == 1) { m = m + sPc; }
		else if (pt3 == 2) { y = y + sPc; }
		else if (pt3 == 3) { k = k + sPc; }
		// rtablir une valeur variable  sa valeur de dpart
		if      (pt4 == 0) { c = xPc; }
		else if (pt4 == 1) { m = xPc; }
		else if (pt4 == 2) { y = xPc; }
		else if (pt4 == 3) { k = xPc; }
	}
	else if (nFix == 2) {
		// augmenter une valeur variable par celle du pas
		if      (pt3 == 0) { c = c + sPc; }
		else if (pt3 == 1) { m = m + sPc; }
		else if (pt3 == 2) { y = y + sPc; }
		else if (pt3 == 3) { k = k + sPc; }
		// rtablir une valeur variable  sa valeur de dpart
		if      (pt4 == 0) { c = xPc; }
		else if (pt4 == 1) { m = xPc; }
		else if (pt4 == 2) { y = xPc; }
		else if (pt4 == 3) { k = xPc; }
	}
	else if (nFix == 3) {
		// rtablir une valeur variable  sa valeur de dpart
		if      (pt4 == 0) { c = xPc; }
		else if (pt4 == 1) { m = xPc; }
		else if (pt4 == 2) { y = xPc; }
		else if (pt4 == 3) { k = xPc; }
	}
	// crer les nuances et les blocs de la range actuelle
	for (var j=0; j<mN; j++) {
		var curValues = [c,m,y,k];
		if (makeSure) {
			var testName = "C=" + c + " M=" + m + " " + yChar + "=" + y + " " + kChar + "=" + k;
			try {
				testColor = curDoc.colors.itemByName(testName).name;
				curColor  = curDoc.colors.itemByName(testName);
			}
			catch (e) {
				curColor  = curDoc.colors.add({colorValue:curValues});
			}
		}
		else {
			curColor = curDoc.colors.add({colorValue:curValues});
		}
		// crer le bloc actuel
		curDoc.rectangles.add({geometricBounds:[y1,x1,y1+fH,x1+fW], fillColor:curColor, fillTint:100, strokeColor:"None"});
		// augmenter la position X par la valeur de dcalage
		x1 = x1+xOff;
		// 
		if (nFix == 0) {
		// augmenter une valeur variable par celle du pas
			if      (pt3 == 0) { c = c + sPc; }
			else if (pt3 == 1) { m = m + sPc; }
			else if (pt3 == 2) { y = y + sPc; }
			else if (pt3 == 3) { k = k + sPc; }
		}
		// augmenter une valeur variable par celle du pas
		if      (pt4 == 0) { c = c + sPc; }
		else if (pt4 == 1) { m = m + sPc; }
		else if (pt4 == 2) { y = y + sPc; }
		else if (pt4 == 3) { k = k + sPc; }
		
	}
	// arrter l'excution aprs la premire range s'il y a trois composants fixes
	if (nFix == 3) { break; }
}

// rendre le document visible
if (mN > nF) {
	curDoc.windows.add();
}

// appeler la fonction pour rtablir les rglages initiales
resetAsBefore();


////////////////////////////// les fonctions  ////////////////////////////////////////////

// la fonction qui prpare les informations
function getPrefs() {
	var allPrefs = "";
	// lire le fichier contenant les valeurs enregistres
	var f = new File("~/Library/Preferences/charte201.txt");
	var fileIsOpen = f.open("r");
	if (fileIsOpen) {
		try {
			allPrefs = f.read();
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
	return allPrefs;
}

// prparer et afficher le dialogue
function displayDialog() {
	try {
		app.dialogs.everyItem().destroy();
	}
	catch (e) {
	}
	var labelWidth0 =  58;
	var labelWidth1 = 125;
	var labelWidth2 =  85;
	var labelWidth3 = 215;
	var labelWidth4 = 225;
	var fieldWidth  =  32;
	var aDialog = app.dialogs.add({name:"Charte de couleurs"});
	with (aDialog) {
		with (dialogColumns.add()) {
			with (dialogRows.add()) {
				with (borderPanels.add()) {
					with (dialogColumns.add()) {
						with (dialogRows.add()) {
							staticTexts.add({staticLabel:"Des valeurs fixes pour les composants activs"});
							staticTexts.add({staticLabel:" ", minWidth:18});
						}
						with (dialogRows.add()) {
							staticTexts.add({staticLabel:" ", minWidth:labelWidth1});
							var cChk = checkboxControls.add({staticLabel:"Cyan",    checkedState:cSt, minWidth:labelWidth2});
							var cVal = integerEditboxes.add({editValue:cFix, minimumValue:0, maximumValue:100, minWidth:fieldWidth});
							staticTexts.add({staticLabel:"%  "});
						}
						with (dialogRows.add()) {
							staticTexts.add({staticLabel:" ", minWidth:labelWidth1});
							var mChk = checkboxControls.add({staticLabel:"Magenta", checkedState:mSt, minWidth:labelWidth2});
							var mVal = integerEditboxes.add({editValue:mFix, minimumValue:0, maximumValue:100, minWidth:fieldWidth});
							staticTexts.add({staticLabel:"%  "});
						}
						with (dialogRows.add()) {
							staticTexts.add({staticLabel:" ", minWidth:labelWidth1});
							var yChk = checkboxControls.add({staticLabel:yelloCol,  checkedState:ySt, minWidth:labelWidth2});
							var yVal = integerEditboxes.add({editValue:yFix, minimumValue:0, maximumValue:100, minWidth:fieldWidth});
							staticTexts.add({staticLabel:"%  "});
						}
						with (dialogRows.add()) {
							staticTexts.add({staticLabel:" ", minWidth:labelWidth1});
							var kChk = checkboxControls.add({staticLabel:blackCol,  checkedState:kSt, minWidth:labelWidth2});
							var kVal = integerEditboxes.add({editValue:kFix, minimumValue:0, maximumValue:100, minWidth:fieldWidth});
							staticTexts.add({staticLabel:"%  "});
						}
					}
				}
			}
			with (dialogRows.add()) {
				with (borderPanels.add()) {
					with (dialogColumns.add()) {
						with (dialogRows.add()) {
							staticTexts.add({staticLabel:"Des valeurs variables pour les autres composants", minWidth:fieldWidth});
						}
						with (dialogRows.add()) {
							staticTexts.add({staticLabel:"La valeur initiale", minWidth:labelWidth3});
							var xValField = realEditboxes.add({editValue:xVal, minimumValue:0, maximumValue:90, minWidth:fieldWidth});
							staticTexts.add({staticLabel:"%  "});
							staticTexts.add({staticLabel:" "});
						}
						with (dialogRows.add()) {
							staticTexts.add({staticLabel:"Le pas", minWidth:labelWidth3});
							var sValField = realEditboxes.add({editValue:stVal, minimumValue:1, maximumValue:25, minWidth:fieldWidth});
							staticTexts.add({staticLabel:"%  "});
							staticTexts.add({staticLabel:" "});
						}
						with (dialogRows.add()) {
							staticTexts.add({staticLabel:"La valeur finale", minWidth:labelWidth3});
							var zValField = realEditboxes.add({editValue:zVal, minimumValue:10, maximumValue:100, minWidth:fieldWidth});
							staticTexts.add({staticLabel:"%  "});
							staticTexts.add({staticLabel:" "});
						}
						with (dialogRows.add()) {
							staticTexts.add({staticLabel:"(val. finale moins val. initiale = multiple du pas)"});
						}
					}
				}
			}
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:"Largeur et hauteur d'un bloc", minWidth:labelWidth4});
				var widthField = realEditboxes.add({editValue:wdVal, minimumValue:1, maximumValue:25, minWidth:fieldWidth});
				staticTexts.add({staticLabel:"mm"});
			}
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:"Distance entre ranges et colonnes", minWidth:labelWidth4});
				var distField = realEditboxes.add({editValue:dVal, minimumValue:0, maximumValue:10, minWidth:fieldWidth});
				staticTexts.add({staticLabel:"mm"});
			}
		}
	}
	if(aDialog.show() == true) {
		var cDec    = cChk.checkedState;
		var cPc     = cVal.editValue;
		var mDec    = mChk.checkedState;
		var mPc     = mVal.editValue;
		var yDec    = yChk.checkedState;
		var yPc     = yVal.editValue;
		var kDec    = kChk.checkedState;
		var kPc     = kVal.editValue;
		var xPc     = xValField.editValue;
		var sPc     = sValField.editValue;
		var zPc     = zValField.editValue;
		var frSize  = widthField.editValue;
		var distVal = distField.editValue;
		// supprimer le dialogue
		aDialog.destroy();
		// la liste des rglages...
		var prefsList = new Array (cDec, mDec, yDec, kDec, cPc, mPc, yPc, kPc, xPc, sPc, zPc, frSize, distVal);
		// ... la transformer en une chane de texte...
		var prefString = prefsList.join("\n");
		// ... et l'envoyer  la fonction qui l'crit dans un fichier
		writeResult(prefString);
		// passer le choix de l'utilisateur aux variables
		var col1 = col2 = col3 = col4 = "";
		var fixTotal = 0;
		if (cDec) { fixTotal = fixTotal+1; }
		if (mDec) { fixTotal = fixTotal+2; }
		if (yDec) { fixTotal = fixTotal+4; }
		if (kDec) { fixTotal = fixTotal+8; }
		if (fixTotal == 0) {
			var nFix = 0;
			var col1 = "Cyan";
			var col2 = "Magenta";
			var col3 = yelloCol;
			var col4 = blackCol;
		}
		else if (fixTotal == 1) {
			var nFix = 1;
			var col2 = "Magenta";
			var col3 = yelloCol;
			var col4 = blackCol;
		}
		else if (fixTotal == 2) {
			var nFix = 1;
			var col2 = "Cyan";
			var col3 = yelloCol;
			var col4 = blackCol;
		}
		else if (fixTotal == 3) {
			var nFix = 2;
			var col3 = yelloCol;
			var col4 = blackCol;
		}
		else if (fixTotal == 4) {
			var nFix = 1;
			var col2 = "Cyan";
			var col3 = "Magenta";
			var col4 = blackCol;
		}
		else if (fixTotal == 5) {
			var nFix = 2;
			var col3 = "Magenta";
			var col4 = blackCol;
		}
		else if (fixTotal == 6) {
			var nFix = 2;
			var col3 = "Cyan";
			var col4 = blackCol;
		}
		else if (fixTotal == 7) {
			var nFix = 3;
			var col4 = blackCol;
		}
		else if (fixTotal == 8) {
			var nFix = 1;
			var col2 = "Cyan";
			var col3 = "Magenta";
			var col4 = yelloCol;
		}
		else if (fixTotal == 9) {
			var nFix = 2;
			var col3 = "Magenta";
			var col4 = yelloCol;
		}
		else if (fixTotal == 10) {
			var nFix = 2;
			var col3 = "Cyan";
			var col4 = yelloCol;
		}
		else if (fixTotal == 11) {
			var nFix = 3;
			var col4 = yelloCol;
		}
		else if (fixTotal == 12) {
			var nFix = 2;
			var col3 = "Cyan";
			var col4 = "Magenta";
		}
		else if (fixTotal == 13) {
			var nFix = 3;
			var col4 = "Magenta";
		}
		else if (fixTotal == 14) {
			var nFix = 3;
			var col4 = "Cyan";
		}
		else if (fixTotal == 15) {
			alert ("Il ne faut pas dfinir les quatre composants comme fixe.", "Stop");
			exit();
		}
		// die Eingabe testen
		if (xPc != (Math.floor(xPc))) {
			alert ("Valeur initiale: uniquement des nombres *entiers* sont admis.", "Stop");
			exit();
		}
		if (sPc != (Math.floor(sPc))) {
			alert ("Le pas: pas de positions dcimales, svp.", "Stop");
			exit();
		}
		if (zPc != (Math.floor(zPc))) {
			alert ("La valeur finale: doit tre un nombre *entier*.", "Stop");
			exit();
		}
		if (xPc>zPc) {
			alert ("La valeur initiale ne peut pas tre plus grande que la valeur finale.", "Stop");
			exit();
		}
		if ((zPc-xPc)<sPc) {
			alert ("Entre la valeur initiale et la valeur finale il doit y avoir au moins une valeur \"pas\".", "Stop");
			exit();
		}
		if ((zPc-xPc)%sPc != 0) {
			alert ("*Valeur finale moins valeur initiale* \ndoit tre un multiple du pas.\n\n( par exemple\nvaleur initiale: " + xPc + " | valeur finale: " + (zPc-((zPc-xPc)%sPc)) + "\nou \nvaleur initiale: " + (zPc%sPc) + " | valeur finale: " + zPc + " )", "Stop");
			exit();
		}
		return [cDec, mDec, yDec, kDec, cPc, mPc, yPc, kPc, col1, col2, col3, col4, nFix, xPc, sPc, zPc, frSize, distVal];
	}
	else {
		aDialog.destroy();
		exit();
	}
}

// rtablir les rglages initiales
function resetAsBefore() {
	if (noDoc == false) {
		// rtablir le point zro (si ncessaire) 
		if (zP != [0,0]) { 
			curDoc.zeroPoint = zP; 
		}
		// rtablir les units de mesure (si ncessaire)
		if (hM != 2053991795) {
			curDoc.viewPreferences.horizontalMeasurementUnits = hM;
		}
		if (vM != 2053991795) {
			curDoc.viewPreferences.verticalMeasurementUnits = vM;
		}
		// verrouiller le calque (si ncessaire)
		if (isLocked) {
			curLayer.locked = true;
		}
	}
}

// crire le rsultat dans un fichier
function writeResult(curPrefs) {
	var f = new File("~/Library/Preferences/charte201.txt");
	var fileIsOpen = f.open("w");
	if (fileIsOpen) {
		try {
			f.write(curPrefs);
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
}